/* queues.c */

#include "queues.h"

void create(struct queue *p)
{
   p->first = NIL;
   p->last = NIL;
}

BOOL empty(struct queue *p)
{
   return(p->first == NIL);
}

struct item *first(struct queue *p)
{
   struct item *paux;

   paux = p->first;
   if (paux != NIL)
   {
      p->first = paux->next;
      if (p->last == paux)
         p->last = NIL;
   }
   return(paux);
}

void add(struct queue *p, struct item *pelem)
{
   struct item *paux;

   paux = p->last;
   if (paux == NIL)
      p->first = pelem;
   else
      paux->next = pelem;
   pelem->next = NIL;
   p->last = pelem;
}

struct item *take(struct queue *p, int number)
{
   struct item *paux, *paur;

   paur = NIL;

   for (paux = p->first; paux != NIL; paux = paux->next)
   {
      if (paux->number > number) paur = paux;
      if (paux->number == number)
      {
         if (paur != NIL) paur->next = paux->next;
         else p->first = paux->next;
         if (paux->next == NIL) p->last = paur;
         return(paux);
      }
      if (paux->number < number) return(NIL);
   }
   return(NIL);
}

void insert(struct queue *p, struct item *pelem)
{
   struct item *paux, *paur;

   paur = NIL;

   for (paux = p->first; paux != NIL; paux = paux->next)
   {
      if (pelem->number <= paux->number) paur = paux;
      else break;
   }
   pelem->next = paux;
   if (paur != NIL) paur->next = pelem;
   else p->first = pelem;
   if (paux == NIL) p->last = pelem;
}
